import os,os.path,string,commands
import cherrypy
#import re
from Common import config,DetConfig
from cherrypy.lib import static
class IOV(object):
    def __init__(self,configfilepath):
        self.__config=config.Config()
        self.__config.from_ini(configfilepath)
        self.__authpath=self.__config.iov.auth_path
        self.__datasavedir=self.__config.iov.datasave_dir
        print 'detector_config ',self.__config.iov.detector_conf
        self.__detconfig=DetConfig.DetConfig(self.__config.iov.detector_conf)
        
    @cherrypy.expose
    def index(self):
        """Top level page
        """
        print self.__authpath
        return "IOVPAGE!!!"
    
    def __getconnectstr(self,det,service,schema,viacache):
        knownservices=self.__detconfig.services(det)
        connect_str=''
        if '/'.join([service,schema]) not in knownservices:
            return ''
        connect_str='oracle://'
        if len(viacache)==0:
            connect_str+=service+'/'+schema          
        else:            
            servletname=self.__detconfig.serviceToServlet(det,service)
            connect_str='frontier://cmsfrontier.cern.ch:8000/'+servletname+'/'+schema
        return connect_str
    
    @cherrypy.expose
    def getTags(self,det,service,schema,viacache):
        """Get list of tags
        """
        #p = re.compile('\w*[\a\n\n\v\t\r();:\'"|~`]\w*')
        #if (p.match(det)!=None or p.match(service) != None) or (p.match(schema) != None) :
        #    return "internal error - unauthourized access"
        connect_str=self.__getconnectstr(det,service,schema,viacache)
        if len(connect_str)==0:
            return "Application Server Error: requested service "+service+" "+schema+"is not configured"
        cmd=['cmscond_list_iov','-a','-c',connect_str]
        if connect_str.find('oracle://') != -1:
            cmd.append('-P')
            cmd.append(self.__authpath)
        cmdstr=' '.join(cmd)
        print cmdstr
        cmdout = commands.getoutput(cmdstr)
        results = string.split(cmdout,'\n')
        result=''
        for entry in results:
            result += entry.strip() +';'
        return result
        
    @cherrypy.expose
    def getIOVForTag(self,det,service,schema,tag,viacache):
        """Get iov info for given tag
        """
        #p = re.compile('\w*[\a\n\n\v\t\r();:\'"|~`]\w*')
        #if (p.match(service) != None) or (p.match(schema) != None) or (p.match(tag)!= None):
        #    return "internal error - unauthourized access"
        connect_str=self.__getconnectstr(det,service,schema,viacache)
        if len(connect_str)==0:
            return "Application Server Error: requested service "+service+" "+schema+"is not configured"
        cmd=['cmscond_list_iov','-t',tag,'-c',connect_str]
        if connect_str.find('oracle://') != -1:
            cmd.append('-P')
            cmd.append(self.__authpath)
        cmdstr=' '.join(cmd)
        cmdout = commands.getoutput(cmdstr)
        results = string.split(cmdout,'\n')
        result=''
        for entry in results:
            result += entry.strip() +';'
        return result

    @cherrypy.expose
    def exportIOV(self,det,service,schema,inputTag,destTag,firstSince,lastTill,filename,viacache):
        """export iov in CMSSW20x format
        """        
        datafile=os.path.join(self.__datasavedir,filename)
        destconnect='sqlite_file://'+datafile
        print 'destconnect',destconnect
        connect_str=self.__getconnecstr(det,service,schema,viacache)
        if len(connect_str)==0:
            return "Application Server Error: requested service "+service+" "+schema+"is not configured"
        sourceconnect=connect_str        
        print 'det',det
        dict=self.__detconfig.dict_name(det)
        cmd = ['cmscond_export_iov','-s',sourceconnect,'-d',destconnect,'-D',dict,'-P',self.__authpath,'-t',destTag]
        if connect_str.find('oracle://') != -1:
            cmd.append('-P')
            cmd.append(self.__authpath)
        if len(inputTag)!=0:
            cmd.append('-i')
            cmd.append(inputTag)
        if len(firstSince)!=0:
            cmd.append('-b')
            cmd.append(firstSince)
        if len(lastTill)!=0:
            cmd.append('-e')
            cmd.append(lastTill)
            
        cmdstr=' '.join(cmd)
        print cmdstr
        cmdout = commands.getoutput(cmdstr)
        print cmdout
        #print os.path.basename(datafile)
        print 'datafile ',datafile
        print 'data path ',os.path.basename(datafile)
        #return static.serve_file(datafile, "application/x-download", "attachment",os.path.basename(datafile))

    
    @cherrypy.expose
    def getFile(self,det,service,schema,tag,viacache,payload,filename):
        """Export selected tag in CMSSW18x compatible format
        """
        datafile=os.path.join(self.__datasavedir,filename)
        destconnect='sqlite_file://'+datafile

        connect_str=self.__getconnecstr(det,service,schema,viacache)
        if len(connect_str)==0:
            return "Application Server Error: requested service "+service+" "+schema+"is not configured"
        sourceconnect=connect_str
        print 'det',det
        dict=self.__detconfig.dict_name(det)
        cmd = ['cmscond_export_iov','-s',sourceconnect,'-d',destconnect,'-D',dict,'-n',payload,'-p',self.__authpath,'-t',tag]
        cmdstr=' '.join(cmd)
        #print cmd
        cmdout = commands.getoutput(cmdstr)
        #print cmdout
        #print os.path.basename(datafile)
        return static.serve_file(datafile, "application/x-download", "attachment",os.path.basename(datafile))

    
    
